local StorageAlertCallHandler = class()
local log = radiant.log.create_logger('storage_alert')
local failed_restock_items = {}

function StorageAlertCallHandler:get_failed_restock_items(session, request)
	if not failed_restock_items[session.player_id] then
		failed_restock_items[session.player_id] = radiant.create_datastore()
		-- this doesn't need to be updated super frequently, but it's a different system than a regular item tracker
		radiant.set_realtime_interval("failed restock items", 2000, function(e)
				self:set_failed_restock_items_data(session.player_id)
			end)
		self:set_failed_restock_items_data(session.player_id)
	end
	return { failed_restock_items = failed_restock_items[session.player_id] }
end

function StorageAlertCallHandler:set_failed_restock_items_data(player_id)
	local cur_data = failed_restock_items[player_id]:get_data().items
	local data = {}
	local restock = stonehearth.constants.inventory.restock_director.types.RESTOCK
	local director = stonehearth.inventory:get_inventory(player_id):get_restock_director(restock)
	
	local items = director._failed_items

	for id, item in pairs(items) do
		data[id] = { uri = item:get_uri(), id = 'object://game/' .. id, time = 0 }
		if cur_data[id] then
			data[id].time = cur_data[id].time + 1
		end
	end

	failed_restock_items[player_id]:set_data({ items = data })
end

return StorageAlertCallHandler